[CCode (cheader_filename = "ccode/valaccodeassignment.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeassignment.h")]
	public class CCodeAssignment : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_assignment_new")]
		public CCodeAssignment (Vala.CCodeExpression l, Vala.CCodeExpression r, Vala.CCodeAssignmentOperator op = CCodeAssignmentOperator.SIMPLE);
		public Vala.CCodeExpression left { get; construct; }
		public weak Vala.CCodeAssignmentOperator operator { get; set; }
		public Vala.CCodeExpression right { get; construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeassignment.h")]
namespace Vala {
	[CCode (cprefix = "VALA_CCODE_ASSIGNMENT_OPERATOR_")]
	public enum CCodeAssignmentOperator {
		SIMPLE,
		BITWISE_OR,
		BITWISE_AND,
		BITWISE_XOR,
		ADD,
		SUB,
		MUL,
		DIV,
		PERCENT,
		SHIFT_LEFT,
		SHIFT_RIGHT,
	}
}
[CCode (cheader_filename = "ccode/valaccodebinaryexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodebinaryexpression.h")]
	public class CCodeBinaryExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_binary_expression_new")]
		public CCodeBinaryExpression (Vala.CCodeBinaryOperator op, Vala.CCodeExpression! l, Vala.CCodeExpression! r);
		public weak Vala.CCodeBinaryOperator operator { get; set; }
		public Vala.CCodeExpression left { get; set construct; }
		public Vala.CCodeExpression right { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodebinaryexpression.h")]
namespace Vala {
	[CCode (cprefix = "VALA_CCODE_BINARY_OPERATOR_")]
	public enum CCodeBinaryOperator {
		PLUS,
		MINUS,
		MUL,
		DIV,
		MOD,
		SHIFT_LEFT,
		SHIFT_RIGHT,
		LESS_THAN,
		GREATER_THAN,
		LESS_THAN_OR_EQUAL,
		GREATER_THAN_OR_EQUAL,
		EQUALITY,
		INEQUALITY,
		BITWISE_AND,
		BITWISE_OR,
		BITWISE_XOR,
		AND,
		OR,
	}
}
[CCode (cheader_filename = "ccode/valaccodeblock.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeblock.h")]
	public class CCodeBlock : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_block_prepend_statement")]
		public void prepend_statement (Vala.CCodeNode! statement);
		[CCode (cname = "vala_ccode_block_add_statement")]
		public void add_statement (Vala.CCodeNode! statement);
		public weak bool suppress_newline { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodebreakstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodebreakstatement.h")]
	public class CCodeBreakStatement : Vala.CCodeStatement {
	}
}
[CCode (cheader_filename = "ccode/valaccodecasestatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodecasestatement.h")]
	public class CCodeCaseStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_case_statement_new")]
		public CCodeCaseStatement (Vala.CCodeExpression! expr);
		[CCode (cname = "vala_ccode_case_statement_add_statement")]
		public void add_statement (Vala.CCodeStatement! stmt);
		public Vala.CCodeExpression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodecastexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodecastexpression.h")]
	public class CCodeCastExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_cast_expression_new")]
		public CCodeCastExpression (Vala.CCodeExpression! expr, string! type);
		public Vala.CCodeExpression inner { get; set construct; }
		public string type_name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodecommaexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodecommaexpression.h")]
	public class CCodeCommaExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_comma_expression_append_expression")]
		public void append_expression (Vala.CCodeExpression! expr);
	}
}
[CCode (cheader_filename = "ccode/valaccodecomment.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodecomment.h")]
	public class CCodeComment : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_comment_new")]
		public CCodeComment (string! _text);
		public string text { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeconditionalexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeconditionalexpression.h")]
	public class CCodeConditionalExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_conditional_expression_new")]
		public CCodeConditionalExpression (Vala.CCodeExpression! cond, Vala.CCodeExpression! true_expr, Vala.CCodeExpression! false_expr);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeExpression true_expression { get; set construct; }
		public Vala.CCodeExpression false_expression { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeconstant.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeconstant.h")]
	public class CCodeConstant : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_constant_new")]
		public CCodeConstant (string! _name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodecontinuestatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodecontinuestatement.h")]
	public class CCodeContinueStatement : Vala.CCodeStatement {
	}
}
[CCode (cheader_filename = "ccode/valaccodedeclaration.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodedeclaration.h")]
	public class CCodeDeclaration : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_declaration_new")]
		public CCodeDeclaration (string! _type_name);
		[CCode (cname = "vala_ccode_declaration_add_declarator")]
		public void add_declarator (Vala.CCodeDeclarator! decl);
		public string type_name { get; set construct; }
		public weak Vala.CCodeModifiers modifiers { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodedeclarator.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodedeclarator.h")]
	public abstract class CCodeDeclarator : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "ccode/valaccodedostatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodedostatement.h")]
	public class CCodeDoStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_do_statement_new")]
		public CCodeDoStatement (Vala.CCodeStatement stmt, Vala.CCodeExpression! cond);
		public Vala.CCodeStatement body { get; set; }
		public Vala.CCodeExpression condition { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeemptystatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeemptystatement.h")]
	public class CCodeEmptyStatement : Vala.CCodeStatement {
	}
}
[CCode (cheader_filename = "ccode/valaccodeenum.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeenum.h")]
	public class CCodeEnum : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_enum_new")]
		public CCodeEnum (string n = null);
		[CCode (cname = "vala_ccode_enum_add_value")]
		public void add_value (string! name, string value = null);
		public string name { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeexpression.h")]
	public abstract class CCodeExpression : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "ccode/valaccodeexpressionstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeexpressionstatement.h")]
	public class CCodeExpressionStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_expression_statement_new")]
		public CCodeExpressionStatement (Vala.CCodeExpression expr);
		public Vala.CCodeExpression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeformalparameter.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeformalparameter.h")]
	public class CCodeFormalParameter : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_formal_parameter_new")]
		public CCodeFormalParameter (string! n, string! type);
		public string name { get; set construct; }
		public string type_name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeforstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeforstatement.h")]
	public class CCodeForStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_for_statement_new")]
		public CCodeForStatement (Vala.CCodeExpression! cond, Vala.CCodeStatement stmt = null);
		[CCode (cname = "vala_ccode_for_statement_add_initializer")]
		public void add_initializer (Vala.CCodeExpression! expr);
		[CCode (cname = "vala_ccode_for_statement_add_iterator")]
		public void add_iterator (Vala.CCodeExpression! expr);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeStatement body { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodefragment.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodefragment.h")]
	public class CCodeFragment : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_fragment_append")]
		public void append (Vala.CCodeNode! node);
		[CCode (cname = "vala_ccode_fragment_get_children")]
		public GLib.List get_children ();
	}
}
[CCode (cheader_filename = "ccode/valaccodefunction.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodefunction.h")]
	public class CCodeFunction : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_function_new")]
		public CCodeFunction (string! _name, string! _return_type);
		[CCode (cname = "vala_ccode_function_add_parameter")]
		public void add_parameter (Vala.CCodeFormalParameter! param);
		[CCode (cname = "vala_ccode_function_copy")]
		public Vala.CCodeFunction! copy ();
		public string name { get; set construct; }
		public weak Vala.CCodeModifiers modifiers { get; set; }
		public string return_type { get; set construct; }
		public Vala.CCodeBlock block { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodefunctioncall.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodefunctioncall.h")]
	public class CCodeFunctionCall : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_function_call_new")]
		public CCodeFunctionCall (Vala.CCodeExpression _call = null);
		[CCode (cname = "vala_ccode_function_call_add_argument")]
		public void add_argument (Vala.CCodeExpression! expr);
		public Vala.CCodeExpression call { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodefunctiondeclarator.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodefunctiondeclarator.h")]
	public class CCodeFunctionDeclarator : Vala.CCodeDeclarator {
		[CCode (cname = "vala_ccode_function_declarator_new")]
		public CCodeFunctionDeclarator (string! n);
		[CCode (cname = "vala_ccode_function_declarator_add_parameter")]
		public void add_parameter (Vala.CCodeFormalParameter! param);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeidentifier.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeidentifier.h")]
	public class CCodeIdentifier : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_identifier_new")]
		public CCodeIdentifier (string! _name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeifstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeifstatement.h")]
	public class CCodeIfStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_if_statement_new")]
		public CCodeIfStatement (Vala.CCodeExpression! cond, Vala.CCodeStatement! true_stmt, Vala.CCodeStatement false_stmt = null);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeStatement true_statement { get; set construct; }
		public Vala.CCodeStatement false_statement { get; set construct; }
		public weak bool else_if { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeincludedirective.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeincludedirective.h")]
	public class CCodeIncludeDirective : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_include_directive_new")]
		public CCodeIncludeDirective (string! _filename, bool _local = false);
		public string filename { get; set construct; }
		public weak bool local { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeinitializerlist.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeinitializerlist.h")]
	public class CCodeInitializerList : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_initializer_list_append")]
		public void append (Vala.CCodeExpression! expr);
	}
}
[CCode (cheader_filename = "ccode/valaccodelinedirective.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodelinedirective.h")]
	public class CCodeLineDirective : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_line_directive_new")]
		public CCodeLineDirective (string! _filename, int _line);
		public string filename { get; set construct; }
		public weak int line { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodemacroreplacement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodemacroreplacement.h")]
	public class CCodeMacroReplacement : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_macro_replacement_new")]
		public CCodeMacroReplacement (string! n, string! replace);
		public string name { get; set construct; }
		public string replacement { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodememberaccess.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodememberaccess.h")]
	public class CCodeMemberAccess : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_member_access_new")]
		public CCodeMemberAccess (Vala.CCodeExpression! container, string! member, bool pointer = false);
		[CCode (cname = "vala_ccode_member_access_new_pointer")]
		public CCodeMemberAccess.pointer (Vala.CCodeExpression! container, string! member);
		public Vala.CCodeExpression inner { get; set construct; }
		public string member_name { get; set construct; }
		public weak bool is_pointer { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodemodifiers.h")]
namespace Vala {
	[CCode (cprefix = "VALA_CCODE_MODIFIERS_")]
	public enum CCodeModifiers {
		NONE,
		STATIC,
		REGISTER,
	}
}
[CCode (cheader_filename = "ccode/valaccodenewline.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodenewline.h")]
	public class CCodeNewline : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "ccode/valaccodenode.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodenode.h")]
	public abstract class CCodeNode : GLib.Object {
		[CCode (cname = "vala_ccode_node_write")]
		public abstract void write (Vala.CCodeWriter! writer);
		public Vala.CCodeLineDirective line { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeoncesection.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeoncesection.h")]
	public class CCodeOnceSection : Vala.CCodeFragment {
		[CCode (cname = "vala_ccode_once_section_new")]
		public CCodeOnceSection (string! def);
		public string define { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeparenthesizedexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeparenthesizedexpression.h")]
	public class CCodeParenthesizedExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_parenthesized_expression_new")]
		public CCodeParenthesizedExpression (Vala.CCodeExpression! expr);
		public Vala.CCodeExpression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodereturnstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodereturnstatement.h")]
	public class CCodeReturnStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_return_statement_new")]
		public CCodeReturnStatement (Vala.CCodeExpression expr = null);
		public Vala.CCodeExpression return_expression { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodestatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodestatement.h")]
	public abstract class CCodeStatement : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "ccode/valaccodestruct.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodestruct.h")]
	public class CCodeStruct : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_struct_new")]
		public CCodeStruct (string! n);
		[CCode (cname = "vala_ccode_struct_add_declaration")]
		public void add_declaration (Vala.CCodeDeclaration! decl);
		[CCode (cname = "vala_ccode_struct_add_field")]
		public void add_field (string! type_name, string! name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeswitchstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeswitchstatement.h")]
	public class CCodeSwitchStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_switch_statement_new")]
		public CCodeSwitchStatement (Vala.CCodeExpression! expr);
		[CCode (cname = "vala_ccode_switch_statement_add_case")]
		public void add_case (Vala.CCodeCaseStatement! case_stmt);
		public Vala.CCodeExpression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodetypedefinition.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodetypedefinition.h")]
	public class CCodeTypeDefinition : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_type_definition_new")]
		public CCodeTypeDefinition (string type, Vala.CCodeDeclarator decl);
		public string type_name { get; set; }
		public Vala.CCodeDeclarator declarator { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeunaryexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeunaryexpression.h")]
	public class CCodeUnaryExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_unary_expression_new")]
		public CCodeUnaryExpression (Vala.CCodeUnaryOperator op, Vala.CCodeExpression! expr);
		public weak Vala.CCodeUnaryOperator operator { get; set; }
		public Vala.CCodeExpression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeunaryexpression.h")]
namespace Vala {
	[CCode (cprefix = "VALA_CCODE_UNARY_OPERATOR_")]
	public enum CCodeUnaryOperator {
		PLUS,
		MINUS,
		LOGICAL_NEGATION,
		BITWISE_COMPLEMENT,
		POINTER_INDIRECTION,
		ADDRESS_OF,
		PREFIX_INCREMENT,
		PREFIX_DECREMENT,
		POSTFIX_INCREMENT,
		POSTFIX_DECREMENT,
	}
}
[CCode (cheader_filename = "ccode/valaccodevariabledeclarator.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodevariabledeclarator.h")]
	public class CCodeVariableDeclarator : Vala.CCodeDeclarator {
		[CCode (cname = "vala_ccode_variable_declarator_new")]
		public CCodeVariableDeclarator (string! _name);
		[CCode (cname = "vala_ccode_variable_declarator_new_with_initializer")]
		public CCodeVariableDeclarator.with_initializer (string! _name, Vala.CCodeExpression init);
		public string name { get; set construct; }
		public Vala.CCodeExpression initializer { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodewhilestatement.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodewhilestatement.h")]
	public class CCodeWhileStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_while_statement_new")]
		public CCodeWhileStatement (Vala.CCodeExpression! cond, Vala.CCodeStatement stmt = null);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeStatement body { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodewriter.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodewriter.h")]
	public class CCodeWriter : GLib.Object {
		[CCode (cname = "vala_ccode_writer_new")]
		public CCodeWriter (string! _filename);
		[CCode (cname = "vala_ccode_writer_close")]
		public void close ();
		[CCode (cname = "vala_ccode_writer_write_indent")]
		public void write_indent ();
		[CCode (cname = "vala_ccode_writer_write_string")]
		public void write_string (string! s);
		[CCode (cname = "vala_ccode_writer_write_newline")]
		public void write_newline ();
		[CCode (cname = "vala_ccode_writer_write_begin_block")]
		public void write_begin_block ();
		[CCode (cname = "vala_ccode_writer_write_end_block")]
		public void write_end_block ();
		[CCode (cname = "vala_ccode_writer_write_comment")]
		public void write_comment (string! text);
		public string filename { get; construct; }
		public weak bool bol { get; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeelementaccess.h")]
namespace Vala {
	[CCode (cheader_filename = "ccode/valaccodeelementaccess.h")]
	public class CCodeElementAccess : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_element_access_new")]
		public CCodeElementAccess (Vala.CCodeExpression! cont, Vala.CCodeExpression! i);
		public Vala.CCodeExpression container { get; set construct; }
		public Vala.CCodeExpression index { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaaddressofexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaaddressofexpression.h")]
	public class AddressofExpression : Vala.Expression {
		[CCode (cname = "vala_addressof_expression_new")]
		public AddressofExpression (Vala.Expression! inner, Vala.SourceReference source_reference = null);
		public Vala.Expression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaarray.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaarray.h")]
	public class Array : Vala.DataType {
		[CCode (cname = "vala_array_new")]
		public Array (Vala.DataType! _element_type, int _rank, Vala.SourceReference! _source_reference);
		[CCode (cname = "vala_array_new_with_type_parameter")]
		public Array.with_type_parameter (Vala.TypeParameter! _element_type_parameter, int _rank, Vala.SourceReference! _source_reference);
		[CCode (cname = "vala_array_get_length_field")]
		public Vala.ArrayLengthField get_length_field ();
		[CCode (cname = "vala_array_get_resize_method")]
		public Vala.ArrayResizeMethod get_resize_method ();
		public Vala.DataType element_type { get; set construct; }
		public Vala.TypeParameter element_type_parameter { get; set construct; }
		public weak int rank { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaarraycreationexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaarraycreationexpression.h")]
	public class ArrayCreationExpression : Vala.Expression {
		[CCode (cname = "vala_array_creation_expression_append_size")]
		public void append_size (Vala.Expression! size);
		[CCode (cname = "vala_array_creation_expression_get_sizes")]
		public GLib.List get_sizes ();
		[CCode (cname = "vala_array_creation_expression_new")]
		public ArrayCreationExpression (Vala.TypeReference _element_type, int _rank, Vala.InitializerList _initializer, Vala.SourceReference source);
		public Vala.TypeReference element_type { get; set construct; }
		public weak int rank { get; set construct; }
		public Vala.InitializerList initializer_list { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaarraylengthfield.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaarraylengthfield.h")]
	public class ArrayLengthField : Vala.Field {
		[CCode (cname = "vala_array_length_field_new")]
		public ArrayLengthField (Vala.SourceReference! source);
	}
}
[CCode (cheader_filename = "vala/valaarrayresizemethod.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaarrayresizemethod.h")]
	public class ArrayResizeMethod : Vala.Method {
		[CCode (cname = "vala_array_resize_method_new")]
		public ArrayResizeMethod (Vala.SourceReference! _source_reference);
	}
}
[CCode (cheader_filename = "vala/valaassignment.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaassignment.h")]
	public class Assignment : Vala.Expression {
		[CCode (cname = "vala_assignment_new")]
		public Assignment (Vala.Expression! _left, Vala.Expression! _right, Vala.AssignmentOperator _op = AssignmentOperator.SIMPLE, Vala.SourceReference _source = null);
		public Vala.Expression left { get; set construct; }
		public weak Vala.AssignmentOperator operator { get; set; }
		public Vala.Expression right { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaassignment.h")]
namespace Vala {
	[CCode (cprefix = "VALA_ASSIGNMENT_OPERATOR_")]
	public enum AssignmentOperator {
		SIMPLE,
		BITWISE_OR,
		BITWISE_AND,
		BITWISE_XOR,
		ADD,
		SUB,
		MUL,
		DIV,
		PERCENT,
		SHIFT_LEFT,
		SHIFT_RIGHT,
	}
}
[CCode (cheader_filename = "vala/valaattribute.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaattribute.h")]
	public class Attribute : Vala.CodeNode {
		public GLib.List<Vala.NamedArgument> args;
		[CCode (cname = "vala_attribute_new")]
		public Attribute (string! _name, Vala.SourceReference source);
		[CCode (cname = "vala_attribute_add_argument")]
		public void add_argument (Vala.NamedArgument! arg);
		[CCode (cname = "vala_attribute_has_argument")]
		public bool has_argument (string! name);
		[CCode (cname = "vala_attribute_get_string")]
		public string get_string (string! name);
		[CCode (cname = "vala_attribute_get_integer")]
		public int get_integer (string! name);
		[CCode (cname = "vala_attribute_get_bool")]
		public bool get_bool (string! name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaattributeprocessor.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaattributeprocessor.h")]
	public class AttributeProcessor : Vala.CodeVisitor {
		[CCode (cname = "vala_attribute_processor_process")]
		public void process (Vala.CodeContext! context);
	}
}
[CCode (cheader_filename = "vala/valabaseaccess.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valabaseaccess.h")]
	public class BaseAccess : Vala.Expression {
		[CCode (cname = "vala_base_access_new")]
		public BaseAccess (Vala.SourceReference source = null);
	}
}
[CCode (cheader_filename = "vala/valabinaryexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valabinaryexpression.h")]
	public class BinaryExpression : Vala.Expression {
		[CCode (cname = "vala_binary_expression_new")]
		public BinaryExpression (Vala.BinaryOperator op, Vala.Expression! _left, Vala.Expression! _right, Vala.SourceReference source = null);
		public weak Vala.BinaryOperator operator { get; set; }
		public Vala.Expression left { get; set construct; }
		public Vala.Expression right { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valabinaryexpression.h")]
namespace Vala {
	[CCode (cprefix = "VALA_BINARY_OPERATOR_")]
	public enum BinaryOperator {
		PLUS,
		MINUS,
		MUL,
		DIV,
		MOD,
		SHIFT_LEFT,
		SHIFT_RIGHT,
		LESS_THAN,
		GREATER_THAN,
		LESS_THAN_OR_EQUAL,
		GREATER_THAN_OR_EQUAL,
		EQUALITY,
		INEQUALITY,
		BITWISE_AND,
		BITWISE_OR,
		BITWISE_XOR,
		AND,
		OR,
	}
}
[CCode (cheader_filename = "vala/valablock.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valablock.h")]
	public class Block : Vala.Statement {
		[CCode (cname = "vala_block_new")]
		public Block (Vala.SourceReference source = null);
		[CCode (cname = "vala_block_add_statement")]
		public void add_statement (Vala.Statement! stmt);
		[CCode (cname = "vala_block_get_statements")]
		public GLib.List get_statements ();
		[CCode (cname = "vala_block_add_local_variable")]
		public void add_local_variable (Vala.VariableDeclarator! decl);
		[CCode (cname = "vala_block_get_local_variables")]
		public GLib.List get_local_variables ();
		public weak bool contains_jump_statement { get; set; }
	}
}
[CCode (cheader_filename = "vala/valabooleanliteral.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valabooleanliteral.h")]
	public class BooleanLiteral : Vala.Literal {
		[CCode (cname = "vala_boolean_literal_new")]
		public BooleanLiteral (bool b, Vala.SourceReference source);
		public weak bool value { get; set; }
	}
}
[CCode (cheader_filename = "vala/valabreakstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valabreakstatement.h")]
	public class BreakStatement : Vala.Statement {
		[CCode (cname = "vala_break_statement_new")]
		public BreakStatement (Vala.SourceReference source);
	}
}
[CCode (cheader_filename = "vala/valacallback.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacallback.h")]
	public class Callback : Vala.DataType {
		[CCode (cname = "vala_callback_new")]
		public Callback (string _name, Vala.TypeReference _return_type, Vala.SourceReference source = null);
		[CCode (cname = "vala_callback_add_type_parameter")]
		public void add_type_parameter (Vala.TypeParameter! p);
		[CCode (cname = "vala_callback_add_parameter")]
		public void add_parameter (Vala.FormalParameter! param);
		[CCode (cname = "vala_callback_get_parameters")]
		public GLib.List get_parameters ();
		[CCode (cname = "vala_callback_matches_method")]
		public bool matches_method (Vala.Method! m);
		public Vala.TypeReference return_type { get; set; }
		public weak bool instance { get; set; }
	}
}
[CCode (cheader_filename = "vala/valacastexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacastexpression.h")]
	public class CastExpression : Vala.Expression {
		[CCode (cname = "vala_cast_expression_new")]
		public CastExpression (Vala.Expression! _inner, Vala.TypeReference! type, Vala.SourceReference source);
		public Vala.Expression inner { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valacatchclause.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacatchclause.h")]
	public class CatchClause : Vala.CodeNode {
		[CCode (cname = "vala_catch_clause_new")]
		public CatchClause (Vala.TypeReference type_reference, string variable_name, Vala.Block body, Vala.SourceReference source_reference = null);
		public Vala.TypeReference type_reference { get; set; }
		public string variable_name { get; set; }
		public Vala.Block body { get; set; }
		public Vala.VariableDeclarator variable_declarator { get; set; }
	}
}
[CCode (cheader_filename = "vala/valacharacterliteral.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacharacterliteral.h")]
	public class CharacterLiteral : Vala.Literal {
		[CCode (cname = "vala_character_literal_new")]
		public CharacterLiteral (string! c, Vala.SourceReference source);
		[CCode (cname = "vala_character_literal_get_char")]
		public unichar get_char ();
		public string value { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaclass.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaclass.h")]
	public class Class : Vala.DataType {
		[CCode (cname = "vala_class_new")]
		public Class (string! _name, Vala.SourceReference source = null);
		[CCode (cname = "vala_class_add_base_type")]
		public void add_base_type (Vala.TypeReference! type);
		[CCode (cname = "vala_class_get_base_types")]
		public GLib.List get_base_types ();
		[CCode (cname = "vala_class_add_type_parameter")]
		public void add_type_parameter (Vala.TypeParameter! p);
		[CCode (cname = "vala_class_add_constant")]
		public void add_constant (Vala.Constant! c);
		[CCode (cname = "vala_class_add_field")]
		public void add_field (Vala.Field! f);
		[CCode (cname = "vala_class_get_fields")]
		public GLib.List get_fields ();
		[CCode (cname = "vala_class_add_method")]
		public void add_method (Vala.Method! m);
		[CCode (cname = "vala_class_get_methods")]
		public GLib.List get_methods ();
		[CCode (cname = "vala_class_add_property")]
		public void add_property (Vala.Property! prop);
		[CCode (cname = "vala_class_get_properties")]
		public GLib.List get_properties ();
		[CCode (cname = "vala_class_add_signal")]
		public void add_signal (Vala.Signal! sig);
		[CCode (cname = "vala_class_get_signals")]
		public GLib.List get_signals ();
		[CCode (cname = "vala_class_set_cname")]
		public void set_cname (string! cname);
		[CCode (cname = "vala_class_process_attributes")]
		public void process_attributes ();
		public Vala.Class base_class { get; set; }
		public weak bool is_abstract { get; set; }
		public weak bool is_static { get; set; }
		public weak bool has_private_fields { get; }
		public Vala.Method default_construction_method { get; set; }
		public Vala.Constructor constructor { get; set; }
		public Vala.Destructor destructor { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaclassregisterfunction.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaclassregisterfunction.h")]
	public class ClassRegisterFunction : Vala.TypeRegisterFunction {
		[CCode (cname = "vala_class_register_function_new")]
		public ClassRegisterFunction (Vala.Class! cl);
		public Vala.Class class_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valacodecontext.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacodecontext.h")]
	public class CodeContext : GLib.Object {
		[CCode (cname = "vala_code_context_get_root")]
		public Vala.Symbol! get_root ();
		[CCode (cname = "vala_code_context_get_source_files")]
		public GLib.List get_source_files ();
		[CCode (cname = "vala_code_context_add_source_file")]
		public void add_source_file (Vala.SourceFile! file);
		[CCode (cname = "vala_code_context_accept")]
		public void accept (Vala.CodeVisitor! visitor);
		[CCode (cname = "vala_code_context_find_header_cycles")]
		public void find_header_cycles ();
		public string library { get; set; }
		public Vala.Method module_init_method { get; set; }
	}
}
[CCode (cheader_filename = "vala/valacodegenerator.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacodegenerator.h")]
	public class CodeGenerator : Vala.CodeVisitor {
		[CCode (cname = "vala_code_generator_new")]
		public CodeGenerator (bool manage_memory = true);
		[CCode (cname = "vala_code_generator_emit")]
		public void emit (Vala.CodeContext! context);
		public weak bool memory_management { get; set; }
	}
}
[CCode (cheader_filename = "vala/valacodenode.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacodenode.h")]
	public abstract class CodeNode : GLib.Object {
		public GLib.List<Vala.Attribute> attributes;
		[CCode (cname = "vala_code_node_accept")]
		public virtual void accept (Vala.CodeVisitor! visitor);
		[CCode (cname = "vala_code_node_replace")]
		public virtual void replace (Vala.CodeNode! old_node, Vala.CodeNode! new_node);
		[CCode (cname = "vala_code_node_get_attribute")]
		public Vala.Attribute get_attribute (string! name);
		[CCode (cname = "vala_code_node_to_string")]
		public virtual string! to_string ();
		public Vala.CodeNode parent_node { get; set; }
		public Vala.Symbol symbol { get; set; }
		public Vala.SourceReference source_reference { get; set construct; }
		public Vala.CCodeNode ccodenode { get; set; }
		public weak bool error { get; set; }
	}
}
[CCode (cheader_filename = "vala/valacodevisitor.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacodevisitor.h")]
	public abstract class CodeVisitor : GLib.Object {
		[CCode (cname = "vala_code_visitor_visit_begin_source_file")]
		public virtual void visit_begin_source_file (Vala.SourceFile! source_file);
		[CCode (cname = "vala_code_visitor_visit_end_source_file")]
		public virtual void visit_end_source_file (Vala.SourceFile! source_file);
		[CCode (cname = "vala_code_visitor_visit_begin_namespace")]
		public virtual void visit_begin_namespace (Vala.Namespace! ns);
		[CCode (cname = "vala_code_visitor_visit_end_namespace")]
		public virtual void visit_end_namespace (Vala.Namespace! ns);
		[CCode (cname = "vala_code_visitor_visit_begin_class")]
		public virtual void visit_begin_class (Vala.Class! cl);
		[CCode (cname = "vala_code_visitor_visit_end_class")]
		public virtual void visit_end_class (Vala.Class! cl);
		[CCode (cname = "vala_code_visitor_visit_begin_struct")]
		public virtual void visit_begin_struct (Vala.Struct! st);
		[CCode (cname = "vala_code_visitor_visit_end_struct")]
		public virtual void visit_end_struct (Vala.Struct! st);
		[CCode (cname = "vala_code_visitor_visit_begin_interface")]
		public virtual void visit_begin_interface (Vala.Interface! iface);
		[CCode (cname = "vala_code_visitor_visit_end_interface")]
		public virtual void visit_end_interface (Vala.Interface! iface);
		[CCode (cname = "vala_code_visitor_visit_begin_enum")]
		public virtual void visit_begin_enum (Vala.Enum! en);
		[CCode (cname = "vala_code_visitor_visit_end_enum")]
		public virtual void visit_end_enum (Vala.Enum! en);
		[CCode (cname = "vala_code_visitor_visit_enum_value")]
		public virtual void visit_enum_value (Vala.EnumValue! ev);
		[CCode (cname = "vala_code_visitor_visit_begin_flags")]
		public virtual void visit_begin_flags (Vala.Flags! fl);
		[CCode (cname = "vala_code_visitor_visit_end_flags")]
		public virtual void visit_end_flags (Vala.Flags! fl);
		[CCode (cname = "vala_code_visitor_visit_flags_value")]
		public virtual void visit_flags_value (Vala.FlagsValue! fv);
		[CCode (cname = "vala_code_visitor_visit_begin_callback")]
		public virtual void visit_begin_callback (Vala.Callback! cb);
		[CCode (cname = "vala_code_visitor_visit_end_callback")]
		public virtual void visit_end_callback (Vala.Callback! cb);
		[CCode (cname = "vala_code_visitor_visit_member")]
		public virtual void visit_member (Vala.Member! m);
		[CCode (cname = "vala_code_visitor_visit_constant")]
		public virtual void visit_constant (Vala.Constant! c);
		[CCode (cname = "vala_code_visitor_visit_field")]
		public virtual void visit_field (Vala.Field! f);
		[CCode (cname = "vala_code_visitor_visit_begin_method")]
		public virtual void visit_begin_method (Vala.Method! m);
		[CCode (cname = "vala_code_visitor_visit_end_method")]
		public virtual void visit_end_method (Vala.Method! m);
		[CCode (cname = "vala_code_visitor_visit_begin_creation_method")]
		public virtual void visit_begin_creation_method (Vala.CreationMethod! m);
		[CCode (cname = "vala_code_visitor_visit_end_creation_method")]
		public virtual void visit_end_creation_method (Vala.CreationMethod! m);
		[CCode (cname = "vala_code_visitor_visit_formal_parameter")]
		public virtual void visit_formal_parameter (Vala.FormalParameter! p);
		[CCode (cname = "vala_code_visitor_visit_begin_property")]
		public virtual void visit_begin_property (Vala.Property! prop);
		[CCode (cname = "vala_code_visitor_visit_end_property")]
		public virtual void visit_end_property (Vala.Property! prop);
		[CCode (cname = "vala_code_visitor_visit_begin_property_accessor")]
		public virtual void visit_begin_property_accessor (Vala.PropertyAccessor! acc);
		[CCode (cname = "vala_code_visitor_visit_end_property_accessor")]
		public virtual void visit_end_property_accessor (Vala.PropertyAccessor! acc);
		[CCode (cname = "vala_code_visitor_visit_begin_signal")]
		public virtual void visit_begin_signal (Vala.Signal! sig);
		[CCode (cname = "vala_code_visitor_visit_end_signal")]
		public virtual void visit_end_signal (Vala.Signal! sig);
		[CCode (cname = "vala_code_visitor_visit_begin_constructor")]
		public virtual void visit_begin_constructor (Vala.Constructor! c);
		[CCode (cname = "vala_code_visitor_visit_end_constructor")]
		public virtual void visit_end_constructor (Vala.Constructor! c);
		[CCode (cname = "vala_code_visitor_visit_begin_destructor")]
		public virtual void visit_begin_destructor (Vala.Destructor! d);
		[CCode (cname = "vala_code_visitor_visit_end_destructor")]
		public virtual void visit_end_destructor (Vala.Destructor! d);
		[CCode (cname = "vala_code_visitor_visit_named_argument")]
		public virtual void visit_named_argument (Vala.NamedArgument! n);
		[CCode (cname = "vala_code_visitor_visit_type_parameter")]
		public virtual void visit_type_parameter (Vala.TypeParameter! p);
		[CCode (cname = "vala_code_visitor_visit_namespace_reference")]
		public virtual void visit_namespace_reference (Vala.NamespaceReference! ns);
		[CCode (cname = "vala_code_visitor_visit_type_reference")]
		public virtual void visit_type_reference (Vala.TypeReference! type);
		[CCode (cname = "vala_code_visitor_visit_begin_block")]
		public virtual void visit_begin_block (Vala.Block! b);
		[CCode (cname = "vala_code_visitor_visit_end_block")]
		public virtual void visit_end_block (Vala.Block! b);
		[CCode (cname = "vala_code_visitor_visit_empty_statement")]
		public virtual void visit_empty_statement (Vala.EmptyStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_declaration_statement")]
		public virtual void visit_declaration_statement (Vala.DeclarationStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_local_variable_declaration")]
		public virtual void visit_local_variable_declaration (Vala.LocalVariableDeclaration! decl);
		[CCode (cname = "vala_code_visitor_visit_variable_declarator")]
		public virtual void visit_variable_declarator (Vala.VariableDeclarator! decl);
		[CCode (cname = "vala_code_visitor_visit_begin_initializer_list")]
		public virtual void visit_begin_initializer_list (Vala.InitializerList! list);
		[CCode (cname = "vala_code_visitor_visit_end_initializer_list")]
		public virtual void visit_end_initializer_list (Vala.InitializerList! list);
		[CCode (cname = "vala_code_visitor_visit_expression_statement")]
		public virtual void visit_expression_statement (Vala.ExpressionStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_if_statement")]
		public virtual void visit_if_statement (Vala.IfStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_switch_statement")]
		public virtual void visit_switch_statement (Vala.SwitchStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_switch_section")]
		public virtual void visit_switch_section (Vala.SwitchSection! section);
		[CCode (cname = "vala_code_visitor_visit_switch_label")]
		public virtual void visit_switch_label (Vala.SwitchLabel! label);
		[CCode (cname = "vala_code_visitor_visit_while_statement")]
		public virtual void visit_while_statement (Vala.WhileStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_do_statement")]
		public virtual void visit_do_statement (Vala.DoStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_for_statement")]
		public virtual void visit_for_statement (Vala.ForStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_begin_foreach_statement")]
		public virtual void visit_begin_foreach_statement (Vala.ForeachStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_end_foreach_statement")]
		public virtual void visit_end_foreach_statement (Vala.ForeachStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_break_statement")]
		public virtual void visit_break_statement (Vala.BreakStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_continue_statement")]
		public virtual void visit_continue_statement (Vala.ContinueStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_begin_return_statement")]
		public virtual void visit_begin_return_statement (Vala.ReturnStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_end_return_statement")]
		public virtual void visit_end_return_statement (Vala.ReturnStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_begin_throw_statement")]
		public virtual void visit_begin_throw_statement (Vala.ThrowStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_end_throw_statement")]
		public virtual void visit_end_throw_statement (Vala.ThrowStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_begin_try_statement")]
		public virtual void visit_begin_try_statement (Vala.TryStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_end_try_statement")]
		public virtual void visit_end_try_statement (Vala.TryStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_begin_catch_clause")]
		public virtual void visit_begin_catch_clause (Vala.CatchClause! clause);
		[CCode (cname = "vala_code_visitor_visit_end_catch_clause")]
		public virtual void visit_end_catch_clause (Vala.CatchClause! clause);
		[CCode (cname = "vala_code_visitor_visit_lock_statement")]
		public virtual void visit_lock_statement (Vala.LockStatement! stmt);
		[CCode (cname = "vala_code_visitor_visit_begin_array_creation_expression")]
		public virtual void visit_begin_array_creation_expression (Vala.ArrayCreationExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_end_array_creation_expression")]
		public virtual void visit_end_array_creation_expression (Vala.ArrayCreationExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_boolean_literal")]
		public virtual void visit_boolean_literal (Vala.BooleanLiteral! lit);
		[CCode (cname = "vala_code_visitor_visit_character_literal")]
		public virtual void visit_character_literal (Vala.CharacterLiteral! lit);
		[CCode (cname = "vala_code_visitor_visit_integer_literal")]
		public virtual void visit_integer_literal (Vala.IntegerLiteral! lit);
		[CCode (cname = "vala_code_visitor_visit_real_literal")]
		public virtual void visit_real_literal (Vala.RealLiteral! lit);
		[CCode (cname = "vala_code_visitor_visit_string_literal")]
		public virtual void visit_string_literal (Vala.StringLiteral! lit);
		[CCode (cname = "vala_code_visitor_visit_null_literal")]
		public virtual void visit_null_literal (Vala.NullLiteral! lit);
		[CCode (cname = "vala_code_visitor_visit_literal_expression")]
		public virtual void visit_literal_expression (Vala.LiteralExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_parenthesized_expression")]
		public virtual void visit_parenthesized_expression (Vala.ParenthesizedExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_member_access")]
		public virtual void visit_member_access (Vala.MemberAccess! expr);
		[CCode (cname = "vala_code_visitor_visit_begin_invocation_expression")]
		public virtual void visit_begin_invocation_expression (Vala.InvocationExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_end_invocation_expression")]
		public virtual void visit_end_invocation_expression (Vala.InvocationExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_element_access")]
		public virtual void visit_element_access (Vala.ElementAccess! expr);
		[CCode (cname = "vala_code_visitor_visit_base_access")]
		public virtual void visit_base_access (Vala.BaseAccess! expr);
		[CCode (cname = "vala_code_visitor_visit_postfix_expression")]
		public virtual void visit_postfix_expression (Vala.PostfixExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_begin_object_creation_expression")]
		public virtual void visit_begin_object_creation_expression (Vala.ObjectCreationExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_end_object_creation_expression")]
		public virtual void visit_end_object_creation_expression (Vala.ObjectCreationExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_typeof_expression")]
		public virtual void visit_typeof_expression (Vala.TypeofExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_unary_expression")]
		public virtual void visit_unary_expression (Vala.UnaryExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_cast_expression")]
		public virtual void visit_cast_expression (Vala.CastExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_pointer_indirection")]
		public virtual void visit_pointer_indirection (Vala.PointerIndirection! expr);
		[CCode (cname = "vala_code_visitor_visit_addressof_expression")]
		public virtual void visit_addressof_expression (Vala.AddressofExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_binary_expression")]
		public virtual void visit_binary_expression (Vala.BinaryExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_type_check")]
		public virtual void visit_type_check (Vala.TypeCheck! expr);
		[CCode (cname = "vala_code_visitor_visit_conditional_expression")]
		public virtual void visit_conditional_expression (Vala.ConditionalExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_begin_lambda_expression")]
		public virtual void visit_begin_lambda_expression (Vala.LambdaExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_end_lambda_expression")]
		public virtual void visit_end_lambda_expression (Vala.LambdaExpression! expr);
		[CCode (cname = "vala_code_visitor_visit_begin_assignment")]
		public virtual void visit_begin_assignment (Vala.Assignment! a);
		[CCode (cname = "vala_code_visitor_visit_end_assignment")]
		public virtual void visit_end_assignment (Vala.Assignment! a);
		[CCode (cname = "vala_code_visitor_visit_end_full_expression")]
		public virtual void visit_end_full_expression (Vala.Expression! expr);
	}
}
[CCode (cheader_filename = "vala/valaconditionalexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaconditionalexpression.h")]
	public class ConditionalExpression : Vala.Expression {
		[CCode (cname = "vala_conditional_expression_new")]
		public ConditionalExpression (Vala.Expression! cond, Vala.Expression! true_expr, Vala.Expression! false_expr, Vala.SourceReference source);
		public Vala.Expression condition { get; set construct; }
		public Vala.Expression true_expression { get; set construct; }
		public Vala.Expression false_expression { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaconstant.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaconstant.h")]
	public class Constant : Vala.Member, Vala.Lockable {
		public Vala.MemberAccessibility access;
		[CCode (cname = "vala_constant_new")]
		public Constant (string! _name, Vala.TypeReference! type, Vala.Expression init, Vala.SourceReference source);
		[CCode (cname = "vala_constant_get_cname")]
		public string! get_cname ();
		[CCode (cname = "vala_constant_get_lock_used")]
		public bool get_lock_used ();
		[CCode (cname = "vala_constant_set_lock_used")]
		public void set_lock_used (bool used);
		public string name { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
		public Vala.Expression initializer { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaconstructor.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaconstructor.h")]
	public class Constructor : Vala.CodeNode {
		[CCode (cname = "vala_constructor_new")]
		public Constructor (Vala.SourceReference source);
		public Vala.Statement body { get; set; }
		public weak bool instance { get; set; }
	}
}
[CCode (cheader_filename = "vala/valacontinuestatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacontinuestatement.h")]
	public class ContinueStatement : Vala.Statement {
		[CCode (cname = "vala_continue_statement_new")]
		public ContinueStatement (Vala.SourceReference source);
	}
}
[CCode (cheader_filename = "vala/valacreationmethod.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valacreationmethod.h")]
	public class CreationMethod : Vala.Method {
		[CCode (cname = "vala_creation_method_new")]
		public CreationMethod (string name, Vala.SourceReference source_reference = null);
		public weak int n_construction_params { get; set; }
	}
}
[CCode (cheader_filename = "vala/valadatatype.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valadatatype.h")]
	public abstract class DataType : Vala.CodeNode {
		public Vala.MemberAccessibility access;
		public weak Vala.Namespace @namespace;
		[CCode (cname = "vala_data_type_get_cname")]
		public abstract string get_cname (bool const_type = false);
		[CCode (cname = "vala_data_type_is_reference_type")]
		public virtual bool is_reference_type ();
		[CCode (cname = "vala_data_type_get_dup_function")]
		public virtual string get_dup_function ();
		[CCode (cname = "vala_data_type_get_free_function")]
		public virtual string get_free_function ();
		[CCode (cname = "vala_data_type_is_reference_counting")]
		public virtual bool is_reference_counting ();
		[CCode (cname = "vala_data_type_get_ref_function")]
		public virtual string get_ref_function ();
		[CCode (cname = "vala_data_type_get_unref_function")]
		public virtual string get_unref_function ();
		[CCode (cname = "vala_data_type_get_type_id")]
		public virtual string get_type_id ();
		[CCode (cname = "vala_data_type_get_marshaller_type_name")]
		public virtual string get_marshaller_type_name ();
		[CCode (cname = "vala_data_type_get_get_value_function")]
		public virtual string get_get_value_function ();
		[CCode (cname = "vala_data_type_get_set_value_function")]
		public virtual string get_set_value_function ();
		[CCode (cname = "vala_data_type_get_upper_case_cname")]
		public virtual string get_upper_case_cname (string infix = null);
		[CCode (cname = "vala_data_type_get_lower_case_cname")]
		public virtual string get_lower_case_cname (string infix = null);
		[CCode (cname = "vala_data_type_get_lower_case_cprefix")]
		public virtual string get_lower_case_cprefix ();
		[CCode (cname = "vala_data_type_get_cheader_filenames")]
		public virtual GLib.List get_cheader_filenames ();
		[CCode (cname = "vala_data_type_add_cheader_filename")]
		public void add_cheader_filename (string! filename);
		[CCode (cname = "vala_data_type_get_pointer")]
		public Vala.Pointer! get_pointer ();
		[CCode (cname = "vala_data_type_get_array")]
		public Vala.Array! get_array (int rank);
		[CCode (cname = "vala_data_type_is_subtype_of")]
		public virtual bool is_subtype_of (Vala.DataType! t);
		[CCode (cname = "vala_data_type_get_type_parameter_index")]
		public virtual int get_type_parameter_index (string! name);
		public string name { get; set; }
	}
}
[CCode (cheader_filename = "vala/valadeclarationstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valadeclarationstatement.h")]
	public class DeclarationStatement : Vala.Statement {
		[CCode (cname = "vala_declaration_statement_new")]
		public DeclarationStatement (Vala.LocalVariableDeclaration! decl, Vala.SourceReference source);
		public Vala.LocalVariableDeclaration declaration { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valadestructor.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valadestructor.h")]
	public class Destructor : Vala.CodeNode {
		[CCode (cname = "vala_destructor_new")]
		public Destructor (Vala.SourceReference source);
		public Vala.Statement body { get; set; }
		public weak bool instance { get; set; }
	}
}
[CCode (cheader_filename = "vala/valadostatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valadostatement.h")]
	public class DoStatement : Vala.Statement {
		[CCode (cname = "vala_do_statement_new")]
		public DoStatement (Vala.Statement! _body, Vala.Expression! cond, Vala.SourceReference source);
		public Vala.Statement body { get; set; }
		public Vala.Expression condition { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaelementaccess.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaelementaccess.h")]
	public class ElementAccess : Vala.Expression {
		[CCode (cname = "vala_element_access_append_index")]
		public void append_index (Vala.Expression! index);
		[CCode (cname = "vala_element_access_get_indices")]
		public GLib.List get_indices ();
		[CCode (cname = "vala_element_access_new")]
		public ElementAccess (Vala.Expression _container, Vala.SourceReference source);
		public Vala.Expression container { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaemptystatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaemptystatement.h")]
	public class EmptyStatement : Vala.Statement {
		[CCode (cname = "vala_empty_statement_new")]
		public EmptyStatement (Vala.SourceReference source);
	}
}
[CCode (cheader_filename = "vala/valaenum.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaenum.h")]
	public class Enum : Vala.DataType {
		[CCode (cname = "vala_enum_new")]
		public Enum (string! _name, Vala.SourceReference source = null);
		[CCode (cname = "vala_enum_add_value")]
		public void add_value (Vala.EnumValue! value);
		[CCode (cname = "vala_enum_get_cprefix")]
		public string! get_cprefix ();
		[CCode (cname = "vala_enum_set_cprefix")]
		public void set_cprefix (string! cprefix);
		[CCode (cname = "vala_enum_process_attributes")]
		public void process_attributes ();
	}
}
[CCode (cheader_filename = "vala/valaenumvalue.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaenumvalue.h")]
	public class EnumValue : Vala.CodeNode {
		[CCode (cname = "vala_enum_value_new")]
		public EnumValue (string! _name);
		[CCode (cname = "vala_enum_value_new_with_value")]
		public EnumValue.with_value (string! _name, Vala.Expression _value);
		[CCode (cname = "vala_enum_value_get_cname")]
		public string! get_cname ();
		public string name { get; set construct; }
		public Vala.Expression value { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaexpression.h")]
	public abstract class Expression : Vala.CodeNode {
		public GLib.List<Vala.VariableDeclarator> temp_vars;
		public Vala.TypeReference static_type { get; set; }
		public Vala.TypeReference expected_type { get; set; }
		public Vala.Symbol symbol_reference { get; set; }
		public weak bool ref_leaked { get; set; }
		public weak bool ref_missing { get; set; }
		public weak bool ref_sink { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaexpressionstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaexpressionstatement.h")]
	public class ExpressionStatement : Vala.Statement {
		[CCode (cname = "vala_expression_statement_new")]
		public ExpressionStatement (Vala.Expression! expr, Vala.SourceReference source = null);
		public Vala.Expression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valafield.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valafield.h")]
	public class Field : Vala.Member, Vala.Invokable, Vala.Lockable {
		public Vala.MemberAccessibility access;
		[CCode (cname = "vala_field_new")]
		public Field (string! _name, Vala.TypeReference! type, Vala.Expression init, Vala.SourceReference source);
		[CCode (cname = "vala_field_get_cname")]
		public string! get_cname ();
		[CCode (cname = "vala_field_process_attributes")]
		public void process_attributes ();
		[CCode (cname = "vala_field_get_parameters")]
		public GLib.List get_parameters ();
		[CCode (cname = "vala_field_get_return_type")]
		public Vala.TypeReference get_return_type ();
		[CCode (cname = "vala_field_is_invokable")]
		public bool is_invokable ();
		[CCode (cname = "vala_field_get_lock_used")]
		public bool get_lock_used ();
		[CCode (cname = "vala_field_set_lock_used")]
		public void set_lock_used (bool used);
		public string name { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
		public Vala.Expression initializer { get; set; }
		public weak bool instance { get; set; }
		public weak bool no_array_length { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaflags.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaflags.h")]
	public class Flags : Vala.DataType {
		[CCode (cname = "vala_flags_new")]
		public Flags (string! _name, Vala.SourceReference source);
		[CCode (cname = "vala_flags_add_value")]
		public void add_value (Vala.FlagsValue! value);
	}
}
[CCode (cheader_filename = "vala/valaflagsvalue.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaflagsvalue.h")]
	public class FlagsValue : Vala.CodeNode {
		[CCode (cname = "vala_flags_value_new")]
		public FlagsValue (string! _name);
		[CCode (cname = "vala_flags_value_new_with_value")]
		public FlagsValue.with_value (string! _name, Vala.Expression _value);
		[CCode (cname = "vala_flags_value_get_cname")]
		public string! get_cname ();
		public string name { get; set construct; }
		public Vala.Expression value { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaforeachstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaforeachstatement.h")]
	public class ForeachStatement : Vala.Statement {
		[CCode (cname = "vala_foreach_statement_new")]
		public ForeachStatement (Vala.TypeReference! type, string! id, Vala.Expression! col, Vala.Statement _body, Vala.SourceReference source);
		public Vala.TypeReference type_reference { get; set construct; }
		public string variable_name { get; set construct; }
		public Vala.Expression collection { get; set construct; }
		public Vala.Statement body { get; set; }
		public Vala.VariableDeclarator variable_declarator { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaformalparameter.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaformalparameter.h")]
	public class FormalParameter : Vala.CodeNode, Vala.Invokable {
		[CCode (cname = "vala_formal_parameter_new")]
		public FormalParameter (string! _name, Vala.TypeReference type, Vala.SourceReference source = null);
		[CCode (cname = "vala_formal_parameter_new_with_ellipsis")]
		public FormalParameter.with_ellipsis (Vala.SourceReference source = null);
		[CCode (cname = "vala_formal_parameter_get_parameters")]
		public GLib.List get_parameters ();
		[CCode (cname = "vala_formal_parameter_get_return_type")]
		public Vala.TypeReference get_return_type ();
		[CCode (cname = "vala_formal_parameter_is_invokable")]
		public bool is_invokable ();
		public string name { get; set construct; }
		public Vala.TypeReference type_reference { get; set; }
		public weak bool ellipsis { get; set; }
		public Vala.Expression default_expression { get; set; }
		public weak bool no_array_length { get; set; }
		public weak bool construct_parameter { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaforstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaforstatement.h")]
	public class ForStatement : Vala.Statement {
		[CCode (cname = "vala_for_statement_new")]
		public ForStatement (Vala.Expression cond, Vala.Statement _body, Vala.SourceReference source);
		[CCode (cname = "vala_for_statement_add_initializer")]
		public void add_initializer (Vala.Expression! init);
		[CCode (cname = "vala_for_statement_get_initializer")]
		public GLib.List get_initializer ();
		[CCode (cname = "vala_for_statement_add_iterator")]
		public void add_iterator (Vala.Expression! iter);
		[CCode (cname = "vala_for_statement_get_iterator")]
		public GLib.List get_iterator ();
		public Vala.Expression condition { get; set construct; }
		public Vala.Statement body { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaifstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaifstatement.h")]
	public class IfStatement : Vala.Statement {
		[CCode (cname = "vala_if_statement_new")]
		public IfStatement (Vala.Expression! cond, Vala.Block! true_stmt, Vala.Block false_stmt, Vala.SourceReference source);
		public Vala.Expression condition { get; set construct; }
		public Vala.Block true_statement { get; set construct; }
		public Vala.Block false_statement { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valainitializerlist.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valainitializerlist.h")]
	public class InitializerList : Vala.Expression {
		[CCode (cname = "vala_initializer_list_append")]
		public void append (Vala.Expression! expr);
		[CCode (cname = "vala_initializer_list_get_initializers")]
		public GLib.List get_initializers ();
		[CCode (cname = "vala_initializer_list_new")]
		public InitializerList (Vala.SourceReference source);
	}
}
[CCode (cheader_filename = "vala/valainstancecast.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valainstancecast.h")]
	public class InstanceCast : Vala.CCodeFunctionCall {
		[CCode (cname = "vala_instance_cast_new")]
		public InstanceCast (Vala.CCodeExpression! expr, Vala.DataType! type);
		public Vala.DataType type_reference { get; set construct; }
		public Vala.CCodeExpression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaintegerliteral.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaintegerliteral.h")]
	public class IntegerLiteral : Vala.Literal {
		[CCode (cname = "vala_integer_literal_new")]
		public IntegerLiteral (string! i, Vala.SourceReference source = null);
		[CCode (cname = "vala_integer_literal_get_type_name")]
		public string! get_type_name ();
		public string value { get; set; }
	}
}
[CCode (cheader_filename = "vala/valainterface.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valainterface.h")]
	public class Interface : Vala.DataType {
		[CCode (cname = "vala_interface_new")]
		public Interface (string! _name, Vala.SourceReference source = null);
		[CCode (cname = "vala_interface_add_type_parameter")]
		public void add_type_parameter (Vala.TypeParameter! p);
		[CCode (cname = "vala_interface_add_prerequisite")]
		public void add_prerequisite (Vala.TypeReference! type);
		[CCode (cname = "vala_interface_get_prerequisites")]
		public GLib.List get_prerequisites ();
		[CCode (cname = "vala_interface_add_method")]
		public void add_method (Vala.Method! m);
		[CCode (cname = "vala_interface_get_methods")]
		public GLib.List get_methods ();
		[CCode (cname = "vala_interface_add_property")]
		public void add_property (Vala.Property! prop);
		[CCode (cname = "vala_interface_get_properties")]
		public GLib.List get_properties ();
		[CCode (cname = "vala_interface_add_signal")]
		public void add_signal (Vala.Signal! sig);
		[CCode (cname = "vala_interface_get_signals")]
		public GLib.List get_signals ();
		[CCode (cname = "vala_interface_get_lower_case_csuffix")]
		public string! get_lower_case_csuffix ();
		[CCode (cname = "vala_interface_set_lower_case_csuffix")]
		public void set_lower_case_csuffix (string! csuffix);
		[CCode (cname = "vala_interface_process_attributes")]
		public void process_attributes ();
		[CCode (cname = "vala_interface_get_type_cname")]
		public string get_type_cname ();
		[CCode (cname = "vala_interface_set_type_cname")]
		public void set_type_cname (string! type_cname);
		public weak bool is_static { get; set; }
	}
}
[CCode (cheader_filename = "vala/valainterfaceregisterfunction.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valainterfaceregisterfunction.h")]
	public class InterfaceRegisterFunction : Vala.TypeRegisterFunction {
		[CCode (cname = "vala_interface_register_function_new")]
		public InterfaceRegisterFunction (Vala.Interface! iface);
		public Vala.Interface interface_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valainterfacewriter.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valainterfacewriter.h")]
	public class InterfaceWriter : Vala.CodeVisitor {
		[CCode (cname = "vala_interface_writer_write_file")]
		public void write_file (Vala.CodeContext! context, string! filename);
	}
}
[CCode (cheader_filename = "vala/valainvocationexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valainvocationexpression.h")]
	public class InvocationExpression : Vala.Expression {
		public Vala.Expression _call;
		[CCode (cname = "vala_invocation_expression_new")]
		public InvocationExpression (Vala.Expression! _call, Vala.SourceReference source = null);
		[CCode (cname = "vala_invocation_expression_add_argument")]
		public void add_argument (Vala.Expression! arg);
		[CCode (cname = "vala_invocation_expression_get_argument_list")]
		public GLib.List get_argument_list ();
		public Vala.Expression call { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valainvokable.h")]
namespace Vala {
	public interface Invokable {
		[CCode (cname = "vala_invokable_is_invokable")]
		public abstract bool is_invokable ();
		[CCode (cname = "vala_invokable_get_return_type")]
		public abstract Vala.TypeReference get_return_type ();
		[CCode (cname = "vala_invokable_get_parameters")]
		public abstract GLib.List get_parameters ();
	}
}
[CCode (cheader_filename = "vala/valalambdaexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valalambdaexpression.h")]
	public class LambdaExpression : Vala.Expression {
		[CCode (cname = "vala_lambda_expression_new")]
		public LambdaExpression (Vala.Expression! body, Vala.SourceReference source);
		[CCode (cname = "vala_lambda_expression_new_with_statement_body")]
		public LambdaExpression.with_statement_body (Vala.Block! body, Vala.SourceReference source);
		[CCode (cname = "vala_lambda_expression_add_parameter")]
		public void add_parameter (string! param);
		[CCode (cname = "vala_lambda_expression_get_parameters")]
		public GLib.List get_parameters ();
		public Vala.Expression expression_body { get; set; }
		public Vala.Block statement_body { get; set; }
		public Vala.Method method { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaliteral.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaliteral.h")]
	public abstract class Literal : Vala.CodeNode {
		public Vala.TypeReference static_type { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaliteralexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaliteralexpression.h")]
	public class LiteralExpression : Vala.Expression {
		[CCode (cname = "vala_literal_expression_new")]
		public LiteralExpression (Vala.Literal! _literal, Vala.SourceReference source = null);
		public Vala.Literal literal { get; construct; }
	}
}
[CCode (cheader_filename = "vala/valalocalvariabledeclaration.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valalocalvariabledeclaration.h")]
	public class LocalVariableDeclaration : Vala.CodeNode {
		[CCode (cname = "vala_local_variable_declaration_new")]
		public LocalVariableDeclaration (Vala.TypeReference type, Vala.SourceReference source);
		[CCode (cname = "vala_local_variable_declaration_new_var_type")]
		public LocalVariableDeclaration.var_type (Vala.SourceReference source);
		[CCode (cname = "vala_local_variable_declaration_add_declarator")]
		public void add_declarator (Vala.VariableDeclarator! declarator);
		[CCode (cname = "vala_local_variable_declaration_get_variable_declarators")]
		public GLib.List get_variable_declarators ();
		public Vala.TypeReference type_reference { get; set; }
	}
}
[CCode (cheader_filename = "vala/valalockable.h")]
namespace Vala {
	public interface Lockable {
		[CCode (cname = "vala_lockable_get_lock_used")]
		public abstract bool get_lock_used ();
		[CCode (cname = "vala_lockable_set_lock_used")]
		public abstract void set_lock_used (bool used);
	}
}
[CCode (cheader_filename = "vala/valalockstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valalockstatement.h")]
	public class LockStatement : Vala.Statement {
		[CCode (cname = "vala_lock_statement_new")]
		public LockStatement (Vala.Expression _resource, Vala.Statement _body, Vala.SourceReference source);
		public Vala.Expression resource { get; set construct; }
		public Vala.Statement body { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valamember.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valamember.h")]
	public class Member : Vala.CodeNode {
	}
}
[CCode (cheader_filename = "vala/valamemberaccess.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valamemberaccess.h")]
	public class MemberAccess : Vala.Expression {
		[CCode (cname = "vala_member_access_new")]
		public MemberAccess (Vala.Expression _inner, string! member, Vala.SourceReference source = null);
		[CCode (cname = "vala_member_access_new_simple")]
		public MemberAccess.simple (string! member, Vala.SourceReference source = null);
		[CCode (cname = "vala_member_access_add_type_argument")]
		public void add_type_argument (Vala.TypeReference! arg);
		[CCode (cname = "vala_member_access_get_type_arguments")]
		public GLib.List get_type_arguments ();
		public Vala.Expression inner { get; set; }
		public string member_name { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valamemberaccessibility.h")]
namespace Vala {
	[CCode (cprefix = "VALA_MEMBER_ACCESSIBILITY_")]
	public enum MemberAccessibility {
		PRIVATE,
		INTERNAL,
		PROTECTED,
		PUBLIC,
	}
}
[CCode (cheader_filename = "vala/valamemorymanager.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valamemorymanager.h")]
	public class MemoryManager : Vala.CodeVisitor {
		[CCode (cname = "vala_memory_manager_analyze")]
		public void analyze (Vala.CodeContext! context);
	}
}
[CCode (cheader_filename = "vala/valamethod.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valamethod.h")]
	public class Method : Vala.Member, Vala.Invokable {
		public Vala.MemberAccessibility access;
		[CCode (cname = "vala_method_new")]
		public Method (string _name, Vala.TypeReference _return_type, Vala.SourceReference source = null);
		[CCode (cname = "vala_method_add_parameter")]
		public void add_parameter (Vala.FormalParameter! param);
		[CCode (cname = "vala_method_get_parameters")]
		public GLib.List get_parameters ();
		[CCode (cname = "vala_method_get_return_type")]
		public Vala.TypeReference get_return_type ();
		[CCode (cname = "vala_method_is_invokable")]
		public bool is_invokable ();
		[CCode (cname = "vala_method_get_cname")]
		public string! get_cname ();
		[CCode (cname = "vala_method_get_default_cname")]
		public virtual string! get_default_cname ();
		[CCode (cname = "vala_method_get_real_cname")]
		public string! get_real_cname ();
		[CCode (cname = "vala_method_set_cname")]
		public void set_cname (string cname);
		[CCode (cname = "vala_method_process_attributes")]
		public void process_attributes ();
		[CCode (cname = "vala_method_equals")]
		public bool equals (Vala.Method! m2);
		public string name { get; set; }
		public Vala.TypeReference return_type { get; set; }
		public Vala.Block body { get; set; }
		public weak bool instance { get; set; }
		public weak bool is_abstract { get; set; }
		public weak bool is_virtual { get; set; }
		public weak bool overrides { get; set; }
		public weak bool returns_modified_pointer { get; set; }
		public weak bool instance_last { get; set; }
		public weak bool instance_by_reference { get; set; }
		public weak Vala.Method base_method { get; set; }
		public Vala.Method base_interface_method { get; set; }
		public Vala.FormalParameter this_parameter { get; set; }
		public weak bool no_array_length { get; set; }
		public weak bool printf_format { get; set; }
	}
}
[CCode (cheader_filename = "vala/valanamedargument.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valanamedargument.h")]
	public class NamedArgument : Vala.CodeNode {
		[CCode (cname = "vala_named_argument_new")]
		public NamedArgument (string! _name, Vala.Expression! arg, Vala.SourceReference source);
		public string name { get; set construct; }
		public Vala.Expression argument { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valanamespace.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valanamespace.h")]
	public class Namespace : Vala.CodeNode {
		[CCode (cname = "vala_namespace_new")]
		public Namespace (string _name, Vala.SourceReference source = null);
		[CCode (cname = "vala_namespace_add_class")]
		public void add_class (Vala.Class! cl);
		[CCode (cname = "vala_namespace_add_interface")]
		public void add_interface (Vala.Interface! iface);
		[CCode (cname = "vala_namespace_add_struct")]
		public void add_struct (Vala.Struct! st);
		[CCode (cname = "vala_namespace_add_enum")]
		public void add_enum (Vala.Enum! en);
		[CCode (cname = "vala_namespace_add_flags")]
		public void add_flags (Vala.Flags! fl);
		[CCode (cname = "vala_namespace_add_callback")]
		public void add_callback (Vala.Callback! cb);
		[CCode (cname = "vala_namespace_get_structs")]
		public GLib.List get_structs ();
		[CCode (cname = "vala_namespace_get_classes")]
		public GLib.List get_classes ();
		[CCode (cname = "vala_namespace_get_interfaces")]
		public GLib.List get_interfaces ();
		[CCode (cname = "vala_namespace_add_constant")]
		public void add_constant (Vala.Constant! constant);
		[CCode (cname = "vala_namespace_add_field")]
		public void add_field (Vala.Field! f);
		[CCode (cname = "vala_namespace_add_method")]
		public void add_method (Vala.Method! m);
		[CCode (cname = "vala_namespace_camel_case_to_lower_case")]
		public static string! camel_case_to_lower_case (string! camel_case);
		[CCode (cname = "vala_namespace_get_cprefix")]
		public string! get_cprefix ();
		[CCode (cname = "vala_namespace_get_lower_case_cprefix")]
		public string! get_lower_case_cprefix ();
		[CCode (cname = "vala_namespace_get_cheader_filenames")]
		public GLib.List get_cheader_filenames ();
		[CCode (cname = "vala_namespace_get_cheader_filename")]
		public string get_cheader_filename ();
		[CCode (cname = "vala_namespace_set_cheader_filename")]
		public void set_cheader_filename (string! cheader_filename);
		[CCode (cname = "vala_namespace_process_attributes")]
		public void process_attributes ();
		public string name { get; set; }
	}
}
[CCode (cheader_filename = "vala/valanamespacereference.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valanamespacereference.h")]
	public class NamespaceReference : Vala.CodeNode {
		[CCode (cname = "vala_namespace_reference_new")]
		public NamespaceReference (string! _name, Vala.SourceReference source);
		public string name { get; set construct; }
		public weak Vala.Symbol namespace_symbol { get; set; }
	}
}
[CCode (cheader_filename = "vala/valanullliteral.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valanullliteral.h")]
	public class NullLiteral : Vala.Literal {
		[CCode (cname = "vala_null_literal_new")]
		public NullLiteral (Vala.SourceReference source = null);
	}
}
[CCode (cheader_filename = "vala/valaobjectcreationexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaobjectcreationexpression.h")]
	public class ObjectCreationExpression : Vala.Expression {
		[CCode (cname = "vala_object_creation_expression_new")]
		public ObjectCreationExpression (Vala.MemberAccess! name, Vala.SourceReference source);
		[CCode (cname = "vala_object_creation_expression_add_argument")]
		public void add_argument (Vala.Expression! arg);
		[CCode (cname = "vala_object_creation_expression_get_argument_list")]
		public GLib.List get_argument_list ();
		public Vala.TypeReference type_reference { get; set; }
		public Vala.Method constructor { get; set; }
		public Vala.MemberAccess member_name { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaparenthesizedexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaparenthesizedexpression.h")]
	public class ParenthesizedExpression : Vala.Expression {
		[CCode (cname = "vala_parenthesized_expression_new")]
		public ParenthesizedExpression (Vala.Expression! _inner, Vala.SourceReference source);
		public Vala.Expression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaparser.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaparser.h")]
	public class Parser : Vala.CodeVisitor {
		[CCode (cname = "vala_parser_parse")]
		public void parse (Vala.CodeContext! context);
		[CCode (cname = "vala_parser_push_comment")]
		public void push_comment (string! comment_item, bool file_comment);
		[CCode (cname = "vala_parser_pop_comment")]
		public string pop_comment ();
		[CCode (cname = "vala_parser_parse_file")]
		public void parse_file (Vala.SourceFile! source_file);
	}
}
[CCode (cheader_filename = "vala/valapointer.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valapointer.h")]
	public class Pointer : Vala.DataType {
		[CCode (cname = "vala_pointer_new")]
		public Pointer (Vala.DataType! referent_type, Vala.SourceReference source_reference = null);
		public Vala.DataType referent_type { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valapointerindirection.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valapointerindirection.h")]
	public class PointerIndirection : Vala.Expression {
		[CCode (cname = "vala_pointer_indirection_new")]
		public PointerIndirection (Vala.Expression! inner, Vala.SourceReference source_reference = null);
		public Vala.Expression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valapostfixexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valapostfixexpression.h")]
	public class PostfixExpression : Vala.Expression {
		[CCode (cname = "vala_postfix_expression_new")]
		public PostfixExpression (Vala.Expression! _inner, bool inc, Vala.SourceReference source);
		public Vala.Expression inner { get; set construct; }
		public weak bool increment { get; set; }
	}
}
[CCode (cheader_filename = "vala/valapropertyaccessor.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valapropertyaccessor.h")]
	public class PropertyAccessor : Vala.CodeNode {
		[CCode (cname = "vala_property_accessor_new")]
		public PropertyAccessor (bool _readable, bool _writable, bool _construction, Vala.Statement _body, Vala.SourceReference source);
		public weak bool readable { get; set; }
		public weak bool writable { get; set; }
		public weak bool construction { get; set; }
		public Vala.Statement body { get; set; }
		public Vala.FormalParameter value_parameter { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaproperty.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaproperty.h")]
	public class Property : Vala.Member, Vala.Lockable {
		[CCode (cname = "vala_property_new")]
		public Property (string! _name, Vala.TypeReference! type, Vala.PropertyAccessor _get_accessor, Vala.PropertyAccessor _set_accessor, Vala.SourceReference source);
		[CCode (cname = "vala_property_get_upper_case_cname")]
		public string! get_upper_case_cname ();
		[CCode (cname = "vala_property_get_canonical_cconstant")]
		public Vala.CCodeConstant! get_canonical_cconstant ();
		[CCode (cname = "vala_property_process_attributes")]
		public void process_attributes ();
		[CCode (cname = "vala_property_get_lock_used")]
		public bool get_lock_used ();
		[CCode (cname = "vala_property_set_lock_used")]
		public void set_lock_used (bool used);
		[CCode (cname = "vala_property_equals")]
		public bool equals (Vala.Property! prop2);
		public string name { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
		public Vala.PropertyAccessor get_accessor { get; set; }
		public Vala.PropertyAccessor set_accessor { get; set; }
		public weak Vala.MemberAccessibility access { get; set; }
		public Vala.FormalParameter this_parameter { get; set; }
		public weak bool no_accessor_method { get; set; }
		public weak bool interface_only { get; set; }
		public weak bool is_abstract { get; set; }
		public weak bool is_virtual { get; set; }
		public weak bool overrides { get; set; }
		public weak Vala.Property base_property { get; set; }
		public Vala.Property base_interface_property { get; set; }
	}
}
[CCode (cheader_filename = "vala/valarealliteral.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valarealliteral.h")]
	public class RealLiteral : Vala.Literal {
		[CCode (cname = "vala_real_literal_new")]
		public RealLiteral (string r, Vala.SourceReference source);
		[CCode (cname = "vala_real_literal_get_type_name")]
		public string! get_type_name ();
		public string value { get; set; }
	}
}
[CCode (cheader_filename = "vala/valareport.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valareport.h")]
	public class Report : GLib.Object {
		[CCode (cname = "vala_report_get_warnings")]
		public static int get_warnings ();
		[CCode (cname = "vala_report_get_errors")]
		public static int get_errors ();
		[CCode (cname = "vala_report_warning")]
		public static void warning (Vala.SourceReference source, string! message);
		[CCode (cname = "vala_report_error")]
		public static void error (Vala.SourceReference source, string! message);
	}
}
[CCode (cheader_filename = "vala/valareturnstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valareturnstatement.h")]
	public class ReturnStatement : Vala.Statement {
		[CCode (cname = "vala_return_statement_new")]
		public ReturnStatement (Vala.Expression result = null, Vala.SourceReference source = null);
		public Vala.Expression return_expression { get; set; }
	}
}
[CCode (cheader_filename = "vala/valasemanticanalyzer.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valasemanticanalyzer.h")]
	public class SemanticAnalyzer : Vala.CodeVisitor {
		[CCode (cname = "vala_semantic_analyzer_new")]
		public SemanticAnalyzer (bool manage_memory = true);
		[CCode (cname = "vala_semantic_analyzer_analyze")]
		public void analyze (Vala.CodeContext! context);
		[CCode (cname = "vala_semantic_analyzer_symbol_lookup_inherited")]
		public static Vala.Symbol symbol_lookup_inherited (Vala.Symbol! sym, string! name);
		public weak bool memory_management { get; set; }
	}
}
[CCode (cheader_filename = "vala/valasignal.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valasignal.h")]
	public class Signal : Vala.Member, Vala.Invokable, Vala.Lockable {
		[CCode (cname = "vala_signal_new")]
		public Signal (string! _name, Vala.TypeReference! _return_type, Vala.SourceReference source);
		[CCode (cname = "vala_signal_add_parameter")]
		public void add_parameter (Vala.FormalParameter! param);
		[CCode (cname = "vala_signal_get_parameters")]
		public GLib.List get_parameters ();
		[CCode (cname = "vala_signal_get_return_type")]
		public Vala.TypeReference get_return_type ();
		[CCode (cname = "vala_signal_is_invokable")]
		public bool is_invokable ();
		[CCode (cname = "vala_signal_get_callback")]
		public Vala.Callback! get_callback ();
		[CCode (cname = "vala_signal_get_cname")]
		public string! get_cname ();
		[CCode (cname = "vala_signal_set_cname")]
		public void set_cname (string cname);
		[CCode (cname = "vala_signal_get_canonical_cconstant")]
		public Vala.CCodeConstant! get_canonical_cconstant ();
		[CCode (cname = "vala_signal_process_attributes")]
		public void process_attributes ();
		[CCode (cname = "vala_signal_get_lock_used")]
		public bool get_lock_used ();
		[CCode (cname = "vala_signal_set_lock_used")]
		public void set_lock_used (bool used);
		public string name { get; set construct; }
		public Vala.TypeReference return_type { get; set construct; }
		public weak Vala.MemberAccessibility access { get; set; }
		public weak bool has_emitter { get; set; }
	}
}
[CCode (cheader_filename = "vala/valasourcefile.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valasourcefile.h")]
	public class SourceFile : GLib.Object {
		[CCode (cname = "vala_source_file_new")]
		public SourceFile (Vala.CodeContext! _context, string! _filename, bool _pkg = false);
		[CCode (cname = "vala_source_file_add_using_directive")]
		public void add_using_directive (Vala.NamespaceReference! ns);
		[CCode (cname = "vala_source_file_get_using_directives")]
		public GLib.List get_using_directives ();
		[CCode (cname = "vala_source_file_add_namespace")]
		public void add_namespace (Vala.Namespace! ns);
		[CCode (cname = "vala_source_file_get_global_namespace")]
		public Vala.Namespace! get_global_namespace ();
		[CCode (cname = "vala_source_file_get_namespaces")]
		public GLib.List get_namespaces ();
		[CCode (cname = "vala_source_file_accept")]
		public void accept (Vala.CodeVisitor! visitor);
		[CCode (cname = "vala_source_file_get_cheader_filename")]
		public string! get_cheader_filename ();
		[CCode (cname = "vala_source_file_get_csource_filename")]
		public string! get_csource_filename ();
		[CCode (cname = "vala_source_file_get_cinclude_filename")]
		public string! get_cinclude_filename ();
		[CCode (cname = "vala_source_file_add_symbol_dependency")]
		public void add_symbol_dependency (Vala.Symbol! sym, Vala.SourceFileDependencyType dep_type);
		[CCode (cname = "vala_source_file_get_header_external_includes")]
		public weak GLib.List get_header_external_includes ();
		[CCode (cname = "vala_source_file_add_header_internal_include")]
		public void add_header_internal_include (string! include);
		[CCode (cname = "vala_source_file_get_header_internal_includes")]
		public weak GLib.List get_header_internal_includes ();
		[CCode (cname = "vala_source_file_get_source_external_includes")]
		public weak GLib.List get_source_external_includes ();
		[CCode (cname = "vala_source_file_get_source_internal_includes")]
		public weak GLib.List get_source_internal_includes ();
		[CCode (cname = "vala_source_file_get_header_internal_full_dependencies")]
		public weak GLib.List get_header_internal_full_dependencies ();
		[CCode (cname = "vala_source_file_get_header_internal_dependencies")]
		public weak GLib.List get_header_internal_dependencies ();
		public string filename { get; set construct; }
		public string comment { get; set; }
		public weak bool pkg { get; set; }
		public Vala.SourceFileCycle cycle { get; set; }
		public weak bool is_cycle_head { get; set; }
		public weak int mark { get; set; }
		public weak Vala.CodeContext context { get; set; }
	}
}
[CCode (cheader_filename = "vala/valasourcefile.h")]
namespace Vala {
	[CCode (cprefix = "VALA_SOURCE_FILE_DEPENDENCY_TYPE_")]
	public enum SourceFileDependencyType {
		HEADER_FULL,
		HEADER_SHALLOW,
		SOURCE,
	}
}
[CCode (cheader_filename = "vala/valasourcefilecycle.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valasourcefilecycle.h")]
	public class SourceFileCycle : GLib.Object {
		public GLib.List<weak Vala.SourceFile> files;
		public weak Vala.SourceFile head;
	}
}
[CCode (cheader_filename = "vala/valasourcereference.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valasourcereference.h")]
	public class SourceReference : GLib.Object {
		[CCode (cname = "vala_source_reference_new")]
		public SourceReference (Vala.SourceFile _file, int _first_line = 0, int _first_column = 0, int _last_line = 0, int _last_column = 0);
		[CCode (cname = "vala_source_reference_new_with_comment")]
		public SourceReference.with_comment (Vala.SourceFile _file, int _first_line, int _first_column, int _last_line, int _last_column, string _comment);
		[CCode (cname = "vala_source_reference_to_string")]
		public string! to_string ();
		public weak Vala.SourceFile file { get; set; }
		public weak int first_line { get; set; }
		public weak int first_column { get; set; }
		public weak int last_line { get; set; }
		public weak int last_column { get; set; }
		public string comment { get; set; }
	}
}
[CCode (cheader_filename = "vala/valastatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valastatement.h")]
	public abstract class Statement : Vala.CodeNode {
		[CCode (cname = "vala_statement_get_number_of_set_construction_parameters")]
		public virtual int get_number_of_set_construction_parameters ();
		public weak bool construction { get; set; }
	}
}
[CCode (cheader_filename = "vala/valastringliteral.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valastringliteral.h")]
	public class StringLiteral : Vala.Literal {
		[CCode (cname = "vala_string_literal_new")]
		public StringLiteral (string s, Vala.SourceReference source);
		[CCode (cname = "vala_string_literal_eval")]
		public string eval ();
		public string value { get; set; }
	}
}
[CCode (cheader_filename = "vala/valastruct.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valastruct.h")]
	public class Struct : Vala.DataType {
		[CCode (cname = "vala_struct_new")]
		public Struct (string! _name, Vala.SourceReference source = null);
		[CCode (cname = "vala_struct_add_type_parameter")]
		public void add_type_parameter (Vala.TypeParameter! p);
		[CCode (cname = "vala_struct_add_constant")]
		public void add_constant (Vala.Constant! c);
		[CCode (cname = "vala_struct_add_field")]
		public void add_field (Vala.Field! f);
		[CCode (cname = "vala_struct_get_fields")]
		public GLib.List get_fields ();
		[CCode (cname = "vala_struct_add_method")]
		public void add_method (Vala.Method! m);
		[CCode (cname = "vala_struct_get_methods")]
		public GLib.List get_methods ();
		[CCode (cname = "vala_struct_is_integer_type")]
		public bool is_integer_type ();
		[CCode (cname = "vala_struct_is_floating_type")]
		public bool is_floating_type ();
		[CCode (cname = "vala_struct_get_rank")]
		public int get_rank ();
		[CCode (cname = "vala_struct_set_is_reference_type")]
		public void set_is_reference_type (bool ref_type);
		[CCode (cname = "vala_struct_process_attributes")]
		public void process_attributes ();
		[CCode (cname = "vala_struct_set_dup_function")]
		public void set_dup_function (string! name);
		[CCode (cname = "vala_struct_set_type_id")]
		public void set_type_id (string! name);
		[CCode (cname = "vala_struct_add_base_type")]
		public void add_base_type (Vala.TypeReference! type);
		[CCode (cname = "vala_struct_get_base_types")]
		public GLib.List get_base_types ();
		public Vala.Method default_construction_method { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaswitchlabel.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaswitchlabel.h")]
	public class SwitchLabel : Vala.CodeNode {
		[CCode (cname = "vala_switch_label_new")]
		public SwitchLabel (Vala.Expression expr, Vala.SourceReference source = null);
		[CCode (cname = "vala_switch_label_new_with_default")]
		public SwitchLabel.with_default (Vala.SourceReference source = null);
		public Vala.Expression expression { get; set; }
	}
}
[CCode (cheader_filename = "vala/valaswitchsection.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaswitchsection.h")]
	public class SwitchSection : Vala.CodeNode {
		[CCode (cname = "vala_switch_section_new")]
		public SwitchSection (Vala.SourceReference source);
		[CCode (cname = "vala_switch_section_add_label")]
		public void add_label (Vala.SwitchLabel! label);
		[CCode (cname = "vala_switch_section_get_labels")]
		public GLib.List get_labels ();
		[CCode (cname = "vala_switch_section_has_default_label")]
		public bool has_default_label ();
		[CCode (cname = "vala_switch_section_add_statement")]
		public void add_statement (Vala.Statement! stmt);
		[CCode (cname = "vala_switch_section_get_statements")]
		public GLib.List get_statements ();
	}
}
[CCode (cheader_filename = "vala/valaswitchstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaswitchstatement.h")]
	public class SwitchStatement : Vala.Statement {
		[CCode (cname = "vala_switch_statement_new")]
		public SwitchStatement (Vala.Expression! expr, Vala.SourceReference source);
		[CCode (cname = "vala_switch_statement_add_section")]
		public void add_section (Vala.SwitchSection! section);
		[CCode (cname = "vala_switch_statement_get_sections")]
		public GLib.List get_sections ();
		public Vala.Expression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valasymbolbuilder.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valasymbolbuilder.h")]
	public class SymbolBuilder : Vala.CodeVisitor {
		[CCode (cname = "vala_symbol_builder_build")]
		public void build (Vala.CodeContext! context);
	}
}
[CCode (cheader_filename = "vala/valasymbol.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valasymbol.h")]
	public class Symbol : GLib.Object {
		[CCode (cname = "vala_symbol_new")]
		public Symbol (Vala.CodeNode _node = null);
		[CCode (cname = "vala_symbol_get_full_name")]
		public string get_full_name ();
		[CCode (cname = "vala_symbol_add")]
		public void add (string! name, Vala.Symbol! sym);
		[CCode (cname = "vala_symbol_lookup")]
		public Vala.Symbol lookup (string! name);
		public weak Vala.CodeNode node { get; set; }
		public weak Vala.Symbol parent_symbol { get; set; }
		public string name { get; set; }
		public weak bool active { get; set; }
	}
}
[CCode (cheader_filename = "vala/valasymbolresolver.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valasymbolresolver.h")]
	public class SymbolResolver : Vala.CodeVisitor {
		[CCode (cname = "vala_symbol_resolver_resolve")]
		public void resolve (Vala.CodeContext! context);
	}
}
[CCode (cheader_filename = "vala/valathrowstatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valathrowstatement.h")]
	public class ThrowStatement : Vala.Statement {
		[CCode (cname = "vala_throw_statement_new")]
		public ThrowStatement (Vala.Expression! error_expression, Vala.SourceReference source_reference = null);
		public Vala.Expression error_expression { get; set; }
	}
}
[CCode (cheader_filename = "vala/valatrystatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valatrystatement.h")]
	public class TryStatement : Vala.Statement {
		[CCode (cname = "vala_try_statement_new")]
		public TryStatement (Vala.Block! body, Vala.Block finally_body, Vala.SourceReference source_reference = null);
		[CCode (cname = "vala_try_statement_add_catch_clause")]
		public void add_catch_clause (Vala.CatchClause! clause);
		public Vala.Block body { get; set construct; }
		public Vala.Block finally_body { get; set; }
	}
}
[CCode (cheader_filename = "vala/valatypecheck.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valatypecheck.h")]
	public class TypeCheck : Vala.Expression {
		[CCode (cname = "vala_type_check_new")]
		public TypeCheck (Vala.Expression! expr, Vala.TypeReference! type, Vala.SourceReference source);
		public Vala.Expression expression { get; set construct; }
		public Vala.TypeReference type_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valatypeofexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valatypeofexpression.h")]
	public class TypeofExpression : Vala.Expression {
		[CCode (cname = "vala_typeof_expression_new")]
		public TypeofExpression (Vala.TypeReference! type, Vala.SourceReference source);
		public Vala.TypeReference type_reference { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valatypeparameter.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valatypeparameter.h")]
	public class TypeParameter : Vala.CodeNode {
		public weak Vala.DataType type;
		[CCode (cname = "vala_type_parameter_new")]
		public TypeParameter (string! _name, Vala.SourceReference source);
		[CCode (cname = "vala_type_parameter_get_array")]
		public Vala.Array! get_array (int rank);
		[CCode (cname = "vala_type_parameter_equals")]
		public bool equals (Vala.TypeParameter! param2);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valatypereference.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valatypereference.h")]
	public class TypeReference : Vala.CodeNode {
		[CCode (cname = "vala_type_reference_new")]
		public TypeReference ();
		[CCode (cname = "vala_type_reference_new_from_name")]
		public TypeReference.from_name (string ns, string! type, Vala.SourceReference source = null);
		[CCode (cname = "vala_type_reference_new_from_expression")]
		public static Vala.TypeReference new_from_expression (Vala.Expression! expr);
		[CCode (cname = "vala_type_reference_add_type_argument")]
		public void add_type_argument (Vala.TypeReference! arg);
		[CCode (cname = "vala_type_reference_get_type_arguments")]
		public GLib.List get_type_arguments ();
		[CCode (cname = "vala_type_reference_get_cname")]
		public string get_cname (bool var_type = false, bool const_type = false);
		[CCode (cname = "vala_type_reference_get_const_cname")]
		public string get_const_cname ();
		[CCode (cname = "vala_type_reference_to_string")]
		public string! to_string ();
		[CCode (cname = "vala_type_reference_copy")]
		public Vala.TypeReference! copy ();
		[CCode (cname = "vala_type_reference_equals")]
		public bool equals (Vala.TypeReference! type2);
		[CCode (cname = "vala_type_reference_stricter")]
		public bool stricter (Vala.TypeReference! type2);
		public weak bool reference_to_value_type { get; set; }
		public weak bool transfers_ownership { get; set; }
		public weak bool takes_ownership { get; set; }
		public weak bool is_out { get; set; }
		public weak bool non_null { get; set; }
		public weak Vala.DataType data_type { get; set; }
		public Vala.TypeParameter type_parameter { get; set; }
		public weak bool floating_reference { get; set; }
		public string namespace_name { get; set; }
		public string type_name { get; set; }
		public weak int array_rank { get; set; }
		public weak int pointer_level { get; set; }
		public weak bool is_ref { get; set; }
		public weak bool is_weak { get; set; }
	}
}
[CCode (cheader_filename = "vala/valatyperegisterfunction.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valatyperegisterfunction.h")]
	public abstract class TypeRegisterFunction : GLib.Object {
		[CCode (cname = "vala_type_register_function_init_from_type")]
		public void init_from_type (bool plugin = false);
		[CCode (cname = "vala_type_register_function_get_type_declaration")]
		public abstract Vala.DataType! get_type_declaration ();
		[CCode (cname = "vala_type_register_function_get_type_struct_name")]
		public abstract string! get_type_struct_name ();
		[CCode (cname = "vala_type_register_function_get_base_init_func_name")]
		public abstract string! get_base_init_func_name ();
		[CCode (cname = "vala_type_register_function_get_class_init_func_name")]
		public abstract string! get_class_init_func_name ();
		[CCode (cname = "vala_type_register_function_get_instance_struct_size")]
		public abstract string! get_instance_struct_size ();
		[CCode (cname = "vala_type_register_function_get_instance_init_func_name")]
		public abstract string! get_instance_init_func_name ();
		[CCode (cname = "vala_type_register_function_get_parent_type_name")]
		public abstract string! get_parent_type_name ();
		[CCode (cname = "vala_type_register_function_get_type_flags")]
		public virtual string get_type_flags ();
		[CCode (cname = "vala_type_register_function_get_type_interface_init_statements")]
		public abstract Vala.CCodeFragment! get_type_interface_init_statements ();
		[CCode (cname = "vala_type_register_function_get_declaration")]
		public Vala.CCodeFragment! get_declaration ();
		[CCode (cname = "vala_type_register_function_get_definition")]
		public Vala.CCodeFragment! get_definition ();
	}
}
[CCode (cheader_filename = "vala/valaunaryexpression.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valaunaryexpression.h")]
	public class UnaryExpression : Vala.Expression {
		[CCode (cname = "vala_unary_expression_new")]
		public UnaryExpression (Vala.UnaryOperator op, Vala.Expression! _inner, Vala.SourceReference source);
		public weak Vala.UnaryOperator operator { get; set; }
		public Vala.Expression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "vala/valaunaryexpression.h")]
namespace Vala {
	[CCode (cprefix = "VALA_UNARY_OPERATOR_")]
	public enum UnaryOperator {
		PLUS,
		MINUS,
		LOGICAL_NEGATION,
		BITWISE_COMPLEMENT,
		INCREMENT,
		DECREMENT,
		REF,
		OUT,
	}
}
[CCode (cheader_filename = "vala/valavariabledeclarator.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valavariabledeclarator.h")]
	public class VariableDeclarator : Vala.CodeNode, Vala.Invokable {
		[CCode (cname = "vala_variable_declarator_new")]
		public VariableDeclarator (string! _name, Vala.Expression init = null, Vala.SourceReference source = null);
		[CCode (cname = "vala_variable_declarator_get_parameters")]
		public GLib.List get_parameters ();
		[CCode (cname = "vala_variable_declarator_get_return_type")]
		public Vala.TypeReference get_return_type ();
		[CCode (cname = "vala_variable_declarator_is_invokable")]
		public bool is_invokable ();
		public string name { get; set construct; }
		public Vala.Expression initializer { get; set; }
		public Vala.TypeReference type_reference { get; set; }
	}
}
[CCode (cheader_filename = "vala/valawhilestatement.h")]
namespace Vala {
	[CCode (cheader_filename = "vala/valawhilestatement.h")]
	public class WhileStatement : Vala.Statement {
		[CCode (cname = "vala_while_statement_new")]
		public WhileStatement (Vala.Expression! cond, Vala.Statement! _body, Vala.SourceReference source);
		public Vala.Expression condition { get; set construct; }
		public Vala.Statement body { get; set; }
	}
}
